#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Oct 14 12:19:54 2019

@author: anshu
"""

import matplotlib.pyplot as plt
from astropy.io import fits
import numpy as np
import tkinter as tk
from tkinter import Tk,Frame,messagebox,Menu
import os
from tkinter import filedialog
import cv2
import os, glob
import random
import math
from os import path
import sys
import subprocess
import pdb
import sunpy
import sunpy.data.sample
import sunpy.map
from sunpy.sun import constants as con
from sunpy.map import header_helper
from astropy.io import fits
import astropy.units as u
from sunpy.coordinates import frames
from astropy.coordinates import SkyCoord
from scipy import ndimage, misc
import matplotlib.pyplot as plt
from matplotlib.backend_bases import key_press_handler
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg, NavigationToolbar2Tk
from matplotlib.figure import Figure
import math
from tkinter.constants import TOP, BOTH, BOTTOM, LEFT
from tkinter.ttk import *
import matplotlib
matplotlib.use("TkAgg")
from matplotlib.figure import Figure
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg
#import pylab


root= tk.Tk()
root.style = Style()
root.style.theme_use("clam")
root.minsize(1200,600)
root.title('Overlay Window')
mainFrame = tk.Frame(root)
mainFrame.grid()
entryFrame = tk.Frame(mainFrame, width=454, height=20)
entryFrame.grid(row=0, column=1)
entryFrame.columnconfigure(0, weight=10)  
entryFrame.grid_propagate(False)



############################ OPEN LASCO PNG#####################

def OpenLASCO():
    global LASCO_file

    LASCO_file=filedialog.askopenfile(initialdir='pwd',title='Select LASCO png file')
    if '.png' in LASCO_file.name:
        print('You have selected LASCO png file correctly')
        
    else:
        messagebox.showerror('Extension Error','You chose a wrong file!! Please choose a png file')
    return None

#################### OPEN GRAPH FITS ##############################
  
def OpenGRAPH():
    global GRAPH_file

    GRAPH_file=filedialog.askopenfile(initialdir='pwd',title='Select GRAPH fits file')
    if '.fits' in GRAPH_file.name:
        print('You have selected GRAPH fits file correctly')
        
    else:
        messagebox.showerror('Extension Error','You chose a wrong file!! Please choose a png file')
    return None

################## READ and PLOT LASCO PNG ###########################  
    
def plotLASCO():
    
    global LASCO_data 
    
    LASCO_data = cv2.imread(LASCO_file.name,0)
    
    figure = Figure(figsize=(12, 6), dpi=100)
    plot = figure.add_subplot(1, 1, 1)
    canvas = FigureCanvasTkAgg(figure, root)
    canvas.get_tk_widget().grid(row=0, column=0)
    
    plot.imshow(LASCO_data, cmap = 'gray', interpolation = 'bicubic')
    
    circle1 = plt.Circle((255, 244), 41, color='b', fill=False)
    plot.set_title('LASCO-C2 + AIA 193A Image')  
    plot.set_yticks([])
    plot.set_xticks([])

    return LASCO_data
                
############# READ and PLOT GRAPH FITS ########################
            
def plotGRAPH():
    
    global grh
    global k
    global grh_rot
    global lev
    global a
    
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]
    ### this is done to remove the text wirtten in LASCO png image in order to bring 
    ## GRAPH and LASCO to same FOV size
    s=(25,512)
    b = np.hstack((np.transpose(grh), np.zeros((grh.shape[1], 25), dtype=grh.dtype)))
    b=np.transpose(b)
    grh=np.resize(b,[512,512])
    
    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k) # Solar North Rotation
    print(a.deg)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    grh_rot = np.flipud(grh_rot) # this has been done beacause axis flip was not working somehow
    
    RA_c=hdu.header['CRVAL1']
    DEC_c=hdu.header['CRVAL2']
    
    figure = Figure(figsize=(12, 6), dpi=100)
    plot = figure.add_subplot(1, 1, 1)
    canvas = FigureCanvasTkAgg(figure, root)
    canvas.get_tk_widget().grid(row=0, column=0)
    
    plot.contour(grh_rot, lev, extend='both')
    circle1 = plt.Circle((255, 255), 41, color='b', fill=False)
    plot.add_artist(circle1)
    plot.set_aspect('equal', 'box')
    plot.set_title('GRAPH Radio contours')
    plot.set_yticks([])
    plot.set_xticks([])

    return grh,k,a,grh_rot

############# PLOT LASCO overlappped with RADIO CONTOURS #############
    
def plotAll():
    
    global LASCO_data
    global grh
    global hdu
    global k
    global grh_rot
    global lev
    
    LASCO_data = cv2.imread(LASCO_file.name,0)
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]


    s=(25,512)
    b = np.hstack((np.transpose(grh), np.zeros((grh.shape[1], 25), dtype=grh.dtype)))
    b=np.transpose(b)
    grh=np.resize(b,[512,512])
    
    
    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    
    figure = Figure(figsize=(12, 6), dpi=100)
    plot = figure.add_subplot(1, 1, 1)
    canvas = FigureCanvasTkAgg(figure, root)
    canvas.get_tk_widget().grid(row=0, column=0)
    plot.imshow(LASCO_data, cmap = 'gray', interpolation = 'bicubic')
    plot.contour(grh_rot, lev, extend='both')
    circle1 = plt.Circle((255, 244), 41, color='b', fill=False)
    plot.add_artist(circle1)
    plot.set_yticks([])
    plot.set_xticks([])
    plot.set_title('Composite Image of LASCO-C2 and GRAPH Radio contours')

    
plt.ioff()   

########## Saving all the images, one can save the plots without display ######
    
def LASCO_png():
    
    
    LASCO_data = cv2.imread(LASCO_file.name,0)
    plt.imshow(LASCO_data, cmap = 'gray', interpolation = 'bicubic')
    plt.title('LASCO-C2 + AIA 193A Image')
    plt.axis('off')
    plt.savefig(LASCO_file.name+'new'+'.png')
    plt.close()

def LASCO_pdf():
    
    LASCO_data = cv2.imread(LASCO_file.name,0)
    plt.imshow(LASCO_data, cmap = 'gray', interpolation = 'bicubic')
    plt.title('LASCO-C2 + AIA 193A Image')
    plt.axis('off')
    plt.savefig(LASCO_file.name+'.pdf')  
    plt.close()
    
def GRAPH_png():
    
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]

    s=(25,512)
    b = np.hstack((np.transpose(grh), np.zeros((grh.shape[1], 25), dtype=grh.dtype)))
    b=np.transpose(b)
    grh=np.resize(b,[512,512])

    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    print(a.deg)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    grh_rot = np.flipud(grh_rot)

    plt.contour(grh_rot, lev, extend='both') 
    ax = plt.gca()
    ax.set_aspect('equal')
    plt.title('GRAPH Radio contours')
    circle1 = plt.Circle((255, 255), 41, color='b', fill=False)
    plt.gcf().gca().add_artist(circle1)
    plt.yticks([])
    plt.xticks([])
    plt.savefig(GRAPH_file.name+'.png') 
    plt.close()
        

def GRAPH_pdf():
    
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]

    s=(25,512)
    b = np.hstack((np.transpose(grh), np.zeros((grh.shape[1], 25), dtype=grh.dtype)))
    b=np.transpose(b)
    grh=np.resize(b,[512,512])

    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    print(a.deg)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    grh_rot = np.flipud(grh_rot)
    plt.contour(grh_rot, lev, extend='both') 

    ax = plt.gca()
    ax.set_aspect('equal')
    plt.title('GRAPH Radio contours')
    circle1 = plt.Circle((255, 255), 41, color='b', fill=False)
    plt.gcf().gca().add_artist(circle1)
    plt.yticks([])
    plt.xticks([])
    plt.savefig(GRAPH_file.name+'.pdf')  
    plt.close()
    
    
def Composite_png():
    
    LASCO_data = cv2.imread(LASCO_file.name,0)
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]

    s=(25,512)
    b = np.hstack((np.transpose(grh), np.zeros((grh.shape[1], 25), dtype=grh.dtype)))
    b=np.transpose(b)
    grh=np.resize(b,[512,512])

    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    plt.imshow(LASCO_data, cmap = 'gray', interpolation = 'bicubic')
    plt.contour(grh_rot, lev, extend='both') 
    plt.title('Composite Image of LASCO-C2 and GRAPH Radio contours')
    plt.axis('off')
    plt.savefig(k+'.png')

    plt.close()

def Composite_pdf():
    
    LASCO_data = cv2.imread(LASCO_file.name,0)
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]

    s=(25,512)
    b = np.hstack((np.transpose(grh), np.zeros((grh.shape[1], 25), dtype=grh.dtype)))
    b=np.transpose(b)
    grh=np.resize(b,[512,512])

    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    plt.imshow(LASCO_data, cmap = 'gray', interpolation = 'bicubic')
    plt.contour(grh_rot, lev, extend='both') 
    plt.title('Composite Image of LASCO-C2 and GRAPH Radio contours')
    plt.axis('off')
    plt.savefig(k+'.pdf')  
    plt.close()

def _quit():
    root.quit()     # stops mainloop
    root.destroy()  # this is necessary on Windows to prevent
                    # Fatal Python Error: PyEval_RestoreThread: NULL tstate


def close():
        if messagebox.askyesno("Overlay plotting tool","Do you really want to exit?"):
            root.destroy()
        else:
            return None





menu = tk.Menu(root)

mfile = tk.Menu(menu)
mfile.add_command(label="OpenLASCO", command=OpenLASCO)
mfile.add_command(label="OpenGRAPH", command=OpenGRAPH)


mplot = tk.Menu(menu)
mplot.add_command(label="Plot LASCO", command=plotLASCO)
mplot.add_command(label="Plot GRAPH", command=plotGRAPH)
mplot.add_command(label="Overlay", command=plotAll)

manalysis = tk.Menu(menu)
manalysis.add_command(label="HT_plot", command=plotLASCO)
manalysis.add_command(label="Width", command=plotGRAPH)
manalysis.add_command(label="...")

msave = tk.Menu(menu)
msave.add_command(label="LASCO_png", command=LASCO_png)
msave.add_command(label="LASCO_pdf", command=LASCO_pdf)
msave.add_command(label="GRAPH_png", command=GRAPH_png)
msave.add_command(label="GRAPH_pdf", command=GRAPH_pdf)
msave.add_command(label="Composite_png", command=Composite_png)
msave.add_command(label="Composite_pdf", command=Composite_pdf)
msave.add_command(label="...")


menu.add_cascade(label='File', menu=mfile)
menu.add_cascade(label='Plot', menu=mplot)
menu.add_cascade(label='Analysis',menu=manalysis)
menu.add_cascade(label='Save',menu=msave)
menu.add_command(label="Close", command=close)


root.config(menu=menu)

#root.mainloop()


