#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Oct 14 12:19:54 2019

@author: anshu
"""

import matplotlib.pyplot as plt
from astropy.io import fits
import numpy as np
import tkinter as tk
from tkinter import Tk,Frame,messagebox,Menu
import os
from tkinter import filedialog
import cv2
import os, glob
import random
import math
from os import path
import sys
import subprocess
import pdb
import sunpy
import sunpy.data.sample
import sunpy.map
from sunpy.sun import constants as con
from sunpy.map import header_helper
from astropy.io import fits
import astropy.units as u
from sunpy.coordinates import frames
from astropy.coordinates import SkyCoord
from scipy import ndimage, misc
import matplotlib.pyplot as plt
from matplotlib.backend_bases import key_press_handler
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg, NavigationToolbar2Tk
from matplotlib.figure import Figure
import math
from tkinter.constants import TOP, BOTH, BOTTOM, LEFT
from tkinter.ttk import *
import matplotlib
matplotlib.use("TkAgg")
from matplotlib.figure import Figure
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg


root= tk.Tk()
root.style = Style()
root.style.theme_use("clam")
root.minsize(1200,600)
root.title('Overlay Window')
mainFrame = tk.Frame(root)
mainFrame.grid()
entryFrame = tk.Frame(mainFrame, width=454, height=20)
entryFrame.grid(row=0, column=1)
entryFrame.columnconfigure(0, weight=10)  
entryFrame.grid_propagate(False)


############################ OPEN LASCO FITS2 #####################


def OpenLASCO1():
    global LASCO_file1

    LASCO_file1=filedialog.askopenfile(initialdir='pwd',title='Select LASCO fits file')
    if '.fts' in LASCO_file1.name:
        print('You have selected LASCO fits file correctly')
        
    else:
        messagebox.showerror('Extension Error','You chose a wrong file!! Please choose a png file')
    return None

############################ OPEN LASCO FITS2 #####################


def OpenLASCO2():
    global LASCO_file2

    LASCO_file2=filedialog.askopenfile(initialdir='pwd',title='Select LASCO fits file')
    if '.fts' in LASCO_file2.name:
        print('You have selected LASCO fits file correctly')
        
    else:
        messagebox.showerror('Extension Error','You chose a wrong file!! Please choose a png file')
    return None

#################### OPEN GRAPH FITS ##############################

  
def OpenGRAPH():
    global GRAPH_file

    GRAPH_file=filedialog.askopenfile(initialdir='pwd',title='Select GRAPH fits file')
    if '.fits' in GRAPH_file.name:
        print('You have selected GRAPH fits file correctly')
        
    else:
        messagebox.showerror('Extension Error','You chose a wrong file!! Please choose a png file')
    return None

 ################## READ and PLOT LASCO PNG ###########################  
   
    
def plotLASCO():
    
    global LASCO_data1
    global LASCO_data2
    global LASCO_diff

    hdulist = fits.open(LASCO_file1.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data1=t*1e12
    
    hdulist = fits.open(LASCO_file2.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data2=t*1e12
    

    LASCO_diff=LASCO_data2-LASCO_data1
    LASCO_diff = np.flipud(LASCO_diff)
    figure = Figure(figsize=(12, 6), dpi=100)
    plot = figure.add_subplot(1, 1, 1)
    canvas = FigureCanvasTkAgg(figure, root)
    canvas.get_tk_widget().grid(row=0, column=0)
    
    plot.imshow(LASCO_diff, cmap = 'gray', interpolation = 'bicubic', vmin  = -500, vmax = 500)
    circle1 = plt.Circle((512, 512), 41*2, color='b', fill=False)
    #plot.gca().invert_yaxis()
    plt.axis('off')
    plot.add_artist(circle1)
    plot.set_title('LASCO-C2 Running Difference Image')  
    plot.axis('off')
    #gca().set_xticklabels([''])
    #ax = plot.gca()
    #ax.set_ylim(ax.get_ylim()[::-1])

    return LASCO_diff
 
############# READ and PLOT GRAPH FITS ########################
               
            
def plotGRAPH():
    
    global grh
    global hdu
    global k
    global grh_rot
    global lev
    
    
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]

    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    print(a.deg)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    grh_rot = np.flipud(grh_rot)
    
    RA_c=hdu.header['CRVAL1']
    DEC_c=hdu.header['CRVAL2']
    
    figure = Figure(figsize=(12, 6), dpi=100)
    plot = figure.add_subplot(1, 1, 1)
    canvas = FigureCanvasTkAgg(figure, root)
    canvas.get_tk_widget().grid(row=0, column=0)
    
    plot.contour(grh_rot, lev, extend='both')
    circle1 = plt.Circle((255, 255), 41, color='b', fill=False)
    plot.add_artist(circle1)
    plot.set_aspect('equal', 'box')
    plot.set_title('GRAPH Radio contours')
    plot.set_yticks([])
    plot.set_xticks([])
  
    return grh,k,a,grh_rot
   

############# PLOT LASCO overlappped with RADIO CONTOURS #############

 
def plotAll():
    
    global LASCO_data1
    global LASCO_data2
    global LASCO_diff
    global grh
    global k
    global grh_rot
    global lev
    
    hdulist = fits.open(LASCO_file1.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data1=t*1e12
    
    hdulist = fits.open(LASCO_file2.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data2=t*1e12
    
    LASCO_diff=LASCO_data2-LASCO_data1
    LASCO_diff = cv2.resize(LASCO_diff, (0,0), fx=0.5, fy=0.5)
    LASCO_diff = np.flipud(LASCO_diff)
    
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]

    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    
    figure = Figure(figsize=(12, 6), dpi=100)
    plot = figure.add_subplot(1, 1, 1)
    canvas = FigureCanvasTkAgg(figure, root)
    canvas.get_tk_widget().grid(row=0, column=0)
    plot.imshow(LASCO_diff, cmap = 'gray', interpolation = 'bicubic', vmin  = -500, vmax = 500)
    plot.contour(grh_rot, lev, extend='both')
    circle1 = plt.Circle((255, 255), 41, color='b', fill=False)
    #plot.gca().invert_yaxis()
    plt.axis('off')
    plot.add_artist(circle1)
    plot.set_yticks([])
    plot.set_xticks([])
    plot.set_title('Composite Image of LASCO-C2 and GRAPH Radio contours')

    
plt.ioff()   
   

########## Saving all the images, one can save the plots without display ######

 
def LASCO_png():
    
    hdulist = fits.open(LASCO_file1.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data1=t*1e12
    
    hdulist = fits.open(LASCO_file2.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data2=t*1e12
    

    LASCO_diff=LASCO_data2-LASCO_data1
    LASCO_diff = np.flipud(LASCO_diff)
   
    circle1 = plt.Circle((512, 512), 41*2, color='b', fill=False)
    plt.axis('off')
    plt.gcf().gca().add_artist(circle1)
    plt.imshow(LASCO_diff, cmap = 'gray', interpolation = 'bicubic', vmin  = -500, vmax = 500)
    plt.title('LASCO-C2 Running Difference Image')
    plt.axis('off')
    plt.savefig(LASCO_file1.name+'.png')
    plt.close()
  

def LASCO_pdf():
    
    hdulist = fits.open(LASCO_file1.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data1=t*1e12
    
    hdulist = fits.open(LASCO_file2.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data2=t*1e12
    

    LASCO_diff=LASCO_data2-LASCO_data1
    LASCO_diff = np.flipud(LASCO_diff)
   
    circle1 = plt.Circle((512,512), 41*2, color='b', fill=False)
    plt.gcf().gca().add_artist(circle1)
    plt.imshow(LASCO_diff, cmap = 'gray', interpolation = 'bicubic', vmin  = -500, vmax = 500)
    plt.title('LASCO-C2 Running Difference Image')
    plt.axis('off')
    plt.savefig(LASCO_file1.name+'.pdf')
    plt.close()

    
def GRAPH_png():
    
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]

    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    print(a.deg)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    grh_rot = np.flipud(grh_rot)
    plt.contour(grh_rot, lev, extend='both') 
    ax = plt.gca()
    ax.set_aspect('equal')
    plt.title('GRAPH Radio contours')
    circle1 = plt.Circle((255, 255), 41, color='b', fill=False)
    plt.gcf().gca().add_artist(circle1)
    plt.yticks([])
    plt.xticks([])
    plt.savefig(GRAPH_file.name+'.png') 
    plt.close()
        

def GRAPH_pdf():
    
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]

    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    print(a.deg)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    grh_rot = np.flipud(grh_rot)
    plt.contour(grh_rot, lev, extend='both') 
    ax = plt.gca()
    ax.set_aspect('equal')
    plt.title('GRAPH Radio contours')
    circle1 = plt.Circle((255, 255), 41, color='b', fill=False)
    plt.gcf().gca().add_artist(circle1)
    plt.yticks([])
    plt.xticks([])
    plt.savefig(GRAPH_file.name+'.pdf')  
    plt.close()
    
    
def Composite_png():
    
    hdulist = fits.open(LASCO_file1.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data1=t*1e12
    
    hdulist = fits.open(LASCO_file2.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data2=t*1e12
    
    LASCO_diff=LASCO_data2-LASCO_data1
    LASCO_diff = cv2.resize(LASCO_diff, (0,0), fx=0.5, fy=0.5)
    LASCO_diff = np.flipud(LASCO_diff)

    
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]

    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    plt.imshow(LASCO_diff, cmap = 'gray', interpolation = 'bicubic', vmin  = -500, vmax = 500)
    plt.contour(grh_rot, lev, extend='both') 
    circle1 = plt.Circle((255, 255), 41, color='b', fill=False)
    plt.gcf().gca().add_artist(circle1)

    plt.title('Composite Image of LASCO-C2 and GRAPH Radio contours')
    plt.axis('off')
    plt.savefig(k+'.png')
    plt.close()

def Composite_pdf():
    
    hdulist = fits.open(LASCO_file1.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data1=t*1e12
    
    hdulist = fits.open(LASCO_file2.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    t=hdu.data
    LASCO_data2=t*1e12
    
    LASCO_diff=LASCO_data2-LASCO_data1
    LASCO_diff = cv2.resize(LASCO_diff, (0,0), fx=0.5, fy=0.5)
    LASCO_diff = np.flipud(LASCO_diff)
    
    hdulist = fits.open(GRAPH_file.name)
    hdulist.info()
    hdu = hdulist[0]
    hdu.data.shape
    grh1=hdu.data
    grh=grh1[0,0,:,:]

    lev=np.linspace(10,100,12)*np.max(grh)/100
    k=hdu.header['DATE-OBS']
    a=sunpy.coordinates.sun.P(k)
    grh_rot = ndimage.rotate(grh, a.deg, reshape=False)
    plt.imshow(LASCO_diff, cmap = 'gray', interpolation = 'bicubic', vmin  = -500, vmax = 500)
    plt.contour(grh_rot, lev, extend='both') 
    circle1 = plt.Circle((255, 255), 41, color='b', fill=False)
    plt.gcf().gca().add_artist(circle1)
  
    plt.title('Composite Image of LASCO-C2 and GRAPH Radio contours')
    plt.axis('off')
    plt.savefig(k+'.pdf')  
    plt.close()

def _quit():
    root.quit()     # stops mainloop
    root.destroy()  # this is necessary on Windows to prevent
                    # Fatal Python Error: PyEval_RestoreThread: NULL tstate


def close():
        if messagebox.askyesno("Overlay plotting tool","Do you really want to exit?"):
            root.destroy()
        else:
            return None





menu = tk.Menu(root)

mfile = tk.Menu(menu)
mfile.add_command(label="OpenLASCO1", command=OpenLASCO1)
mfile.add_command(label="OpenLASCO2", command=OpenLASCO2)
mfile.add_command(label="OpenGRAPH", command=OpenGRAPH)


mplot = tk.Menu(menu)
mplot.add_command(label="Plot LASCO", command=plotLASCO)
mplot.add_command(label="Plot GRAPH", command=plotGRAPH)
mplot.add_command(label="Overlay", command=plotAll)

manalysis = tk.Menu(menu)
manalysis.add_command(label="HT_plot", command=plotLASCO)
manalysis.add_command(label="Width", command=plotGRAPH)
manalysis.add_command(label="...")

msave = tk.Menu(menu)
msave.add_command(label="LASCO_png", command=LASCO_png)
msave.add_command(label="LASCO_pdf", command=LASCO_pdf)
msave.add_command(label="GRAPH_png", command=GRAPH_png)
msave.add_command(label="GRAPH_pdf", command=GRAPH_pdf)
msave.add_command(label="Composite_png", command=Composite_png)
msave.add_command(label="Composite_pdf", command=Composite_pdf)
msave.add_command(label="...")


menu.add_cascade(label='File', menu=mfile)
menu.add_cascade(label='Plot', menu=mplot)
menu.add_cascade(label='Analysis',menu=manalysis)
menu.add_cascade(label='Save',menu=msave)
menu.add_command(label="Close", command=close)


root.config(menu=menu)

#root.mainloop()


